## Top Level API Objects

- v1beta1.Deployment

- v1beta1.DeploymentList

- v1beta1.DeploymentRollback

- v1beta1.Scale

- v1beta1.StatefulSet

- v1beta1.StatefulSetList

- v1beta1.ControllerRevision

- v1beta1.ControllerRevisionList

## Definitions

### v1beta1.DeploymentStatus

DeploymentStatus is the most recently observed status of the Deployment.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
observedGeneration | The generation observed by the deployment controller. | false | integer (int64) |
replicas | Total number of non-terminated pods targeted by this deployment (their labels match the selector). | false | integer (int32) |
updatedReplicas | Total number of non-terminated pods targeted by this deployment that have the desired template spec. | false | integer (int32) |
readyReplicas | Total number of ready pods targeted by this deployment. | false | integer (int32) |
availableReplicas | Total number of available pods (ready for at least minReadySeconds) targeted by this deployment. | false | integer (int32) |
unavailableReplicas | Total number of unavailable pods targeted by this deployment. This is the total number of pods that are still required for the deployment to have 100% available capacity. They may either be pods that are running but not yet available or pods that still have not been created. | false | integer (int32) |
conditions | Represents the latest available observations of a deployment’s current state. | false | v1beta1.DeploymentCondition array |
collisionCount | Count of hash collisions for the Deployment. The Deployment controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ReplicaSet. | false | integer (int32) |

### v1.APIResourceList

APIResourceList is a list of APIResource, it is used to expose the name of the resources supported in a specific group and version, and if the resource is namespaced.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
groupVersion | groupVersion is the group and version this APIResourceList is for. | true | string |
resources | resources contains the name of the resources and if they are namespaced. | true | v1.APIResource array |

### v1.Affinity

Affinity is a group of affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
nodeAffinity | Describes node affinity scheduling rules for the pod. | false | v1.NodeAffinity |
podAffinity | Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)). | false | v1.PodAffinity |
podAntiAffinity | Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)). | false | v1.PodAntiAffinity |

### v1beta1.RollingUpdateStatefulSetStrategy

RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
partition | Partition indicates the ordinal at which the StatefulSet should be partitioned. | false | integer (int32) |

### v1.NodeSelectorTerm

A null or empty node selector term matches no objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
matchExpressions | Required. A list of node selector requirements. The requirements are ANDed. | true | v1.NodeSelectorRequirement array |

### v1.Preconditions

Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
uid | Specifies the target UID. | false | types.UID |

### v1.ObjectFieldSelector

ObjectFieldSelector selects an APIVersioned field of an object.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
apiVersion | Version of the schema the FieldPath is written in terms of, defaults to "v1". | false | string |
fieldPath | Path of the field to select in the specified API version. | true | string |

### v1.SELinuxOptions

SELinuxOptions are the labels to be applied to the container

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
user | User is a SELinux user label that applies to the container. | false | string |
role | Role is a SELinux role label that applies to the container. | false | string |
type | Type is a SELinux type label that applies to the container. | false | string |
level | Level is SELinux level label that applies to the container. | false | string |

### v1.VolumeMount

VolumeMount describes a mounting of a Volume within a container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | This must match the Name of a Volume. | true | string |
readOnly | Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false. | false | boolean | false
mountPath | Path within the container at which the volume should be mounted. Must not contain :. | true | string |
subPath | Path within the volume from which the container’s volume should be mounted. Defaults to "" (volume’s root). | false | string |
mountPropagation | mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationHostToContainer is used. This field is alpha in 1.8 and can be reworked or removed in a future release. | false | v1.MountPropagationMode |

### v1.MountPropagationMode

### v1.DownwardAPIProjection

Represents downward API info for projecting into a projected volume. Note that this is identical to a downwardAPI volume source without the default mode.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
items | Items is a list of DownwardAPIVolume file | false | v1.DownwardAPIVolumeFile array |

### v1.LabelSelector

A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
matchLabels | matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. | false | object |
matchExpressions | matchExpressions is a list of label selector requirements. The requirements are ANDed. | false | v1.LabelSelectorRequirement array |

### v1.PersistentVolumeClaimSpec

PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
accessModes | AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1 | false | v1.PersistentVolumeAccessMode array |
selector | A label query over volumes to consider for binding. | false | v1.LabelSelector |
resources | Resources represents the minimum resources the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources | false | v1.ResourceRequirements |
volumeName | VolumeName is the binding reference to the PersistentVolume backing this claim. | false | string |
storageClassName | Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1 | false | string |
volumeMode | volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec. This is an alpha feature and may change in the future. | false | v1.PersistentVolumeMode |

### v1.CephFSVolumeSource

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
monitors | Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | true | string array |
path | Optional: Used as the mounted root, rather than the full Ceph tree, default is / | false | string |
user | Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | string |
secretFile | Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | string |
secretRef | Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | v1.LocalObjectReference |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | boolean | false

### v1.DownwardAPIVolumeSource

DownwardAPIVolumeSource represents a volume containing downward API info. Downward API volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
items | Items is a list of downward API volume file | false | v1.DownwardAPIVolumeFile array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.GCEPersistentDiskVolumeSource

Represents a Persistent Disk resource in Google Compute Engine.

A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
pdName | Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk | false | string |
partition | The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk | false | integer (int32) |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk | false | boolean | false

### v1beta1.RollingUpdateDeployment

Spec to control the desired behavior of rolling update.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
maxUnavailable | The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods. | false | string |
maxSurge | The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods. | false | string |

### v1.ConfigMapVolumeSource

Adapts a ConfigMap into a volume.

The contents of the target ConfigMap’s Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |
optional | Specify whether the ConfigMap or it’s keys must be defined | false | boolean | false

### v1.GitRepoVolumeSource

Represents a volume that is populated with the contents of a git repository. Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
repository | Repository URL | true | string |
revision | Commit hash for the specified revision. | false | string |
directory | Target directory name. Must not contain or start with ... If . is supplied, the volume directory will be the git repository. Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name. | false | string |

### v1.SecretEnvSource

SecretEnvSource selects a Secret to populate the environment variables with.

The contents of the target Secret’s Data field will represent the key-value pairs as environment variables.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
optional | Specify whether the Secret must be defined | false | boolean | false

### v1.PortworxVolumeSource

PortworxVolumeSource represents a Portworx volume resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeID | VolumeID uniquely identifies a Portworx volume | true | string |
fsType | FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### v1.Capabilities

Adds and removes POSIX capabilities from running containers.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
add | Added capabilities | false | v1.Capability array |
drop | Removed capabilities | false | v1.Capability array |

### v1.Initializer

Initializer is information about an initializer that has not yet completed.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | name of the process that is responsible for initializing this object. | true | string |

### v1.LocalObjectReference

LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |

### v1.ProjectedVolumeSource

Represents a projected volume source

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
sources | list of volume projections | true | v1.VolumeProjection array |
defaultMode | Mode bits to use on created files by default. Must be a value between 0 and 0777. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1beta1.StatefulSetSpec

A StatefulSetSpec is the specification of a StatefulSet.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
replicas | replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1. | false | integer (int32) |
selector | selector is a label query over pods that should match the replica count. If empty, defaulted to labels on the pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors | false | v1.LabelSelector |
template | template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet. | true | v1.PodTemplateSpec |
volumeClaimTemplates | volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name. | false | v1.PersistentVolumeClaim array |
serviceName | serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where "pod-specific-string" is managed by the StatefulSet controller. | true | string |
podManagementPolicy | podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once. | false | string |
updateStrategy | updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. | false | v1beta1.StatefulSetUpdateStrategy |
revisionHistoryLimit | revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet’s revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10. | false | integer (int32) |

### v1.ExecAction

ExecAction describes a "run in container" action.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
command | Command is the command line to execute inside the container, the working directory for the command is root (/) in the container’s filesystem. The command is simply exec’d, it is not run inside a shell, so traditional shell instructions (' | ', etc) won’t work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. | false | string array

### v1.ObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
generateName | GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server. If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header). Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency | false | string |
namespace | Namespace defines the space within each name must be unique. An empty namespace is equivalent to the "default" namespace, but "default" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty. Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces | false | string |
selfLink | SelfLink is a URL representing this object. Populated by the system. Read-only. | false | string |
uid | UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations. Populated by the system. Read-only. More info: http://kubernetes.io/docs/user-guide/identifiers#uids | false | string |
resourceVersion | An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources. Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency | false | string |
generation | A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. | false | integer (int64) |
creationTimestamp | CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC. Populated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | string |
deletionTimestamp | DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested. Populated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | string |
deletionGracePeriodSeconds | Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. | false | integer (int64) |
labels | Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels | false | object |
annotations | Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations | false | object |
ownerReferences | List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. | false | v1.OwnerReference array |
initializers | An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven’t explicitly asked to observe uninitialized objects. When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user. | false | v1.Initializers |
finalizers | Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. | false | string array |
clusterName | The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. | false | string |

### v1beta1.Deployment

DEPRECATED - This group version of Deployment is deprecated by apps/v1beta2/Deployment. See the release notes for more information. Deployment enables declarative updates for Pods and ReplicaSets.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard object metadata. | false | v1.ObjectMeta |
spec | Specification of the desired behavior of the Deployment. | false | v1beta1.DeploymentSpec |
status | Most recently observed status of the Deployment. | false | v1beta1.DeploymentStatus |

### v1.AzureFileVolumeSource

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
secretName | the name of secret that contains Azure Storage Account Name and Key | true | string |
shareName | Share Name | true | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### types.UID

### v1.ISCSIVolumeSource

Represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
targetPortal | iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260). | true | string |
iqn | Target iSCSI Qualified Name. | true | string |
lun | iSCSI Target Lun number. | true | integer (int32) |
iscsiInterface | iSCSI Interface Name that uses an iSCSI transport. Defaults to default (tcp). | false | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi | false | string |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. | false | boolean | false
portals | iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260). | false | string array |
chapAuthDiscovery | whether support iSCSI Discovery CHAP authentication | false | boolean | false
chapAuthSession | whether support iSCSI Session CHAP authentication | false | boolean | false
secretRef | CHAP Secret for iSCSI target and initiator authentication | false | v1.LocalObjectReference |
initiatorName | Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection. | false | string |

### v1.EmptyDirVolumeSource

Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
medium | What type of storage medium should back this directory. The default is "" which means to use the node’s default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir | false | string |
sizeLimit | Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir | false | string |

### v1beta1.ScaleSpec

ScaleSpec describes the attributes of a scale subresource

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
replicas | desired number of instances for the scaled object. | false | integer (int32) |

### v1.PodAffinityTerm

Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
labelSelector | A label query over a set of resources, in this case pods. | false | v1.LabelSelector |
namespaces | namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means "this pod’s namespace" | false | string array |
topologyKey | This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed. | true | string |

### v1.EnvFromSource

EnvFromSource represents the source of a set of ConfigMaps

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
prefix | An optional identifer to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER. | false | string |
configMapRef | The ConfigMap to select from | false | v1.ConfigMapEnvSource |
secretRef | The Secret to select from | false | v1.SecretEnvSource |

### v1beta1.StatefulSetCondition

StatefulSetCondition describes the state of a statefulset at a certain point.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type | Type of statefulset condition. | true | string |
status | Status of the condition, one of True, False, Unknown. | true | string |
lastTransitionTime | Last time the condition transitioned from one status to another. | false | string |
reason | The reason for the condition’s last transition. | false | string |
message | A human readable message indicating details about the transition. | false | string |

### v1.PersistentVolumeClaim

PersistentVolumeClaim is a user’s request for and claim to a persistent volume

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard object’s metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | v1.ObjectMeta |
spec | Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims | false | v1.PersistentVolumeClaimSpec |
status | Status represents the current information/status of a persistent volume claim. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims | false | v1.PersistentVolumeClaimStatus |

### v1.PodAffinity

Pod affinity is a group of inter pod affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. | false | v1.PodAffinityTerm array |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. | false | v1.WeightedPodAffinityTerm array |

### v1.FlockerVolumeSource

Represents a Flocker volume mounted by the Flocker agent. One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
datasetName | Name of the dataset stored as metadata → name on the dataset for Flocker should be considered as deprecated | false | string |
datasetUUID | UUID of the dataset. This is unique identifier of a Flocker dataset | false | string |

### v1.PersistentVolumeClaimVolumeSource

PersistentVolumeClaimVolumeSource references the user’s PVC in the same namespace. This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
claimName | ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims | true | string |
readOnly | Will force the ReadOnly setting in VolumeMounts. Default false. | false | boolean | false

### v1.ListMeta

ListMeta describes metadata that synthetic resources must have, including lists and various status objects. A resource may have only one of {ObjectMeta, ListMeta}.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
selfLink | selfLink is a URL representing this object. Populated by the system. Read-only. | false | string |
resourceVersion | String that identifies the server’s internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency | false | string |
continue | continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response. | false | string |

### v1.PersistentVolumeClaimStatus

PersistentVolumeClaimStatus is the current status of a persistent volume claim.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
phase | Phase represents the current phase of PersistentVolumeClaim. | false | string |
accessModes | AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1 | false | v1.PersistentVolumeAccessMode array |
capacity | Represents the actual resources of the underlying volume. | false | object |
conditions | Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to ResizeStarted. | false | v1.PersistentVolumeClaimCondition array |

### v1beta1.RollbackConfig

DEPRECATED.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
revision | The revision to rollback to. If set to 0, rollback to the last revision. | false | integer (int64) |

### v1.PersistentVolumeClaimCondition

PersistentVolumeClaimCondition contails details about state of pvc

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type |  | true | string |
status |  | true | string |
lastProbeTime | Last time we probed the condition. | false | string |
lastTransitionTime | Last time the condition transitioned from one status to another. | false | string |
reason | Unique, this should be a short, machine understandable string that gives the reason for condition’s last transition. If it reports "ResizeStarted" that means the underlying persistent volume is being resized. | false | string |
message | Human-readable message indicating details about last transition. | false | string |

### v1.SecretVolumeSource

Adapts a Secret into a volume.

The contents of the target Secret’s Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
secretName | Name of the secret in the pod’s namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |
optional | Specify whether the Secret or it’s keys must be defined | false | boolean | false

### v1.FlexVolumeSource

FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
driver | Driver is the name of the driver to use for this volume. | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script. | false | string |
secretRef | Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts. | false | v1.LocalObjectReference |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false
options | Optional: Extra command options if any. | false | object |

### v1.EnvVarSource

EnvVarSource represents a source for the value of an EnvVar.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
fieldRef | Selects a field of the pod: supports metadata.name, metadata.namespace, metadata.labels, metadata.annotations, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP. | false | v1.ObjectFieldSelector |
resourceFieldRef | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported. | false | v1.ResourceFieldSelector |
configMapKeyRef | Selects a key of a ConfigMap. | false | v1.ConfigMapKeySelector |
secretKeyRef | Selects a key of a secret in the pod’s namespace | false | v1.SecretKeySelector |

### v1.KeyToPath

Maps a string key to a path within a volume.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | The key to project. | true | string |
path | The relative path of the file to map the key to. May not be an absolute path. May not contain the path element ... May not start with the string ... | true | string |
mode | Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.AzureDiskVolumeSource

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
diskName | The Name of the data disk in the blob storage | true | string |
diskURI | The URI the data disk in the blob storage | true | string |
cachingMode | Host Caching mode: None, Read Only, Read Write. | false | v1.AzureDataDiskCachingMode |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false
kind | Expected values Shared: multiple blob disks per storage account Dedicated: single blob disk per storage account Managed: azure managed data disk (only in managed availability set). defaults to shared | false | v1.AzureDataDiskKind |

### v1.VsphereVirtualDiskVolumeSource

Represents a vSphere volume resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumePath | Path that identifies vSphere volume vmdk | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
storagePolicyName | Storage Policy Based Management (SPBM) profile name. | false | string |
storagePolicyID | Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName. | false | string |

### v1.PersistentVolumeMode

### v1.DeleteOptions

DeleteOptions may be provided when deleting an API object.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
gracePeriodSeconds | The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately. | false | integer (int64) |
preconditions | Must be fulfilled before a deletion is carried out. If not possible, a 409 Conflict status will be returned. | false | v1.Preconditions |
orphanDependents | Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object’s finalizers list. Either this field or PropagationPolicy may be set, but not both. | false | boolean | false
propagationPolicy | Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: Orphan - orphan the dependents; Background - allow the garbage collector to delete the dependents in the background; Foreground - a cascading policy that deletes all dependents in the foreground. | false | v1.DeletionPropagation |

### v1beta1.StatefulSet

DEPRECATED - This group version of StatefulSet is deprecated by apps/v1beta2/StatefulSet. See the release notes for more information. StatefulSet represents a set of pods with consistent identities. Identities are defined as:
- Network: A single stable DNS and hostname.
- Storage: As many VolumeClaims as requested.
The StatefulSet guarantees that a given network identity will always map to the same storage identity.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata |  | false | v1.ObjectMeta |
spec | Spec defines the desired identities of pods in this set. | false | v1beta1.StatefulSetSpec |
status | Status is the current status of Pods in this StatefulSet. This data may be out of date by some window of time. | false | v1beta1.StatefulSetStatus |

### v1.Volume

Volume represents a named volume in a pod that may be accessed by any container in the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Volume’s name. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | true | string |
hostPath | HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath | false | v1.HostPathVolumeSource |
emptyDir | EmptyDir represents a temporary directory that shares a pod’s lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir | false | v1.EmptyDirVolumeSource |
gcePersistentDisk | GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk | false | v1.GCEPersistentDiskVolumeSource |
awsElasticBlockStore | AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore | false | v1.AWSElasticBlockStoreVolumeSource |
gitRepo | GitRepo represents a git repository at a particular revision. | false | v1.GitRepoVolumeSource |
secret | Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret | false | v1.SecretVolumeSource |
nfs | NFS represents an NFS mount on the host that shares a pod’s lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs | false | v1.NFSVolumeSource |
iscsi | ISCSI represents an ISCSI Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: https://releases.k8s.io/HEAD/examples/volumes/iscsi/README.md | false | v1.ISCSIVolumeSource |
glusterfs | Glusterfs represents a Glusterfs mount on the host that shares a pod’s lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md | false | v1.GlusterfsVolumeSource |
persistentVolumeClaim | PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims | false | v1.PersistentVolumeClaimVolumeSource |
rbd | RBD represents a Rados Block Device mount on the host that shares a pod’s lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md | false | v1.RBDVolumeSource |
flexVolume | FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. | false | v1.FlexVolumeSource |
cinder | Cinder represents a cinder volume attached and mounted on kubelets host machine More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | v1.CinderVolumeSource |
cephfs | CephFS represents a Ceph FS mount on the host that shares a pod’s lifetime | false | v1.CephFSVolumeSource |
flocker | Flocker represents a Flocker volume attached to a kubelet’s host machine. This depends on the Flocker control service being running | false | v1.FlockerVolumeSource |
downwardAPI | DownwardAPI represents downward API about the pod that should populate this volume | false | v1.DownwardAPIVolumeSource |
fc | FC represents a Fibre Channel resource that is attached to a kubelet’s host machine and then exposed to the pod. | false | v1.FCVolumeSource |
azureFile | AzureFile represents an Azure File Service mount on the host and bind mount to the pod. | false | v1.AzureFileVolumeSource |
configMap | ConfigMap represents a configMap that should populate this volume | false | v1.ConfigMapVolumeSource |
vsphereVolume | VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine | false | v1.VsphereVirtualDiskVolumeSource |
quobyte | Quobyte represents a Quobyte mount on the host that shares a pod’s lifetime | false | v1.QuobyteVolumeSource |
azureDisk | AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. | false | v1.AzureDiskVolumeSource |
photonPersistentDisk | PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine | false | v1.PhotonPersistentDiskVolumeSource |
projected | Items for all in one resources secrets, configmaps, and downward API | false | v1.ProjectedVolumeSource |
portworxVolume | PortworxVolume represents a portworx volume attached and mounted on kubelets host machine | false | v1.PortworxVolumeSource |
scaleIO | ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes. | false | v1.ScaleIOVolumeSource |
storageos | StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes. | false | v1.StorageOSVolumeSource |

### v1.ResourceFieldSelector

ResourceFieldSelector represents container resources (cpu, memory) and their output format

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
containerName | Container name: required for volumes, optional for env vars | false | string |
resource | Required: resource to select | true | string |
divisor | Specifies the output format of the exposed resources, defaults to "1" | false | string |

### v1.VolumeProjection

Projection that may be projected along with other supported volume types

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
secret | information about the secret data to project | false | v1.SecretProjection |
downwardAPI | information about the downwardAPI data to project | false | v1.DownwardAPIProjection |
configMap | information about the configMap data to project | false | v1.ConfigMapProjection |

### v1.WeightedPodAffinityTerm

The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
weight | weight associated with matching the corresponding podAffinityTerm, in the range 1-100. | true | integer (int32) |
podAffinityTerm | Required. A pod affinity term, associated with the corresponding weight. | true | v1.PodAffinityTerm |

### v1.Probe

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
exec | One and only one of the following should be specified. Exec specifies the action to take. | false | v1.ExecAction |
httpGet | HTTPGet specifies the http request to perform. | false | v1.HTTPGetAction |
tcpSocket | TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported | false | v1.TCPSocketAction |
initialDelaySeconds | Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes | false | integer (int32) |
timeoutSeconds | Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes | false | integer (int32) |
periodSeconds | How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. | false | integer (int32) |
successThreshold | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1. | false | integer (int32) |
failureThreshold | Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. | false | integer (int32) |

### v1beta1.DeploymentSpec

DeploymentSpec is the specification of the desired behavior of the Deployment.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
replicas | Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1. | false | integer (int32) |
selector | Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. | false | v1.LabelSelector |
template | Template describes the pods that will be created. | true | v1.PodTemplateSpec |
strategy | The deployment strategy to use to replace existing pods with new ones. | false | v1beta1.DeploymentStrategy |
minReadySeconds | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready) | false | integer (int32) |
revisionHistoryLimit | The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 2. | false | integer (int32) |
paused | Indicates that the deployment is paused. | false | boolean | false
rollbackTo | DEPRECATED. The config this deployment is rolling back to. Will be cleared after rollback is done. | false | v1beta1.RollbackConfig |
progressDeadlineSeconds | The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s. | false | integer (int32) |

### v1.SecretKeySelector

SecretKeySelector selects a key of a Secret.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
key | The key of the secret to select from. Must be a valid secret key. | true | string |
optional | Specify whether the Secret or it’s key must be defined | false | boolean | false

### v1.Capability

### v1.DownwardAPIVolumeFile

DownwardAPIVolumeFile represents information to create the file containing the pod field

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Required: Path is the relative path name of the file to be created. Must not be absolute or contain the .. path. Must be utf-8 encoded. The first item of the relative path must not start with .. | true | string |
fieldRef | Required: Selects a field of the pod: only annotations, labels, name and namespace are supported. | false | v1.ObjectFieldSelector |
resourceFieldRef | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported. | false | v1.ResourceFieldSelector |
mode | Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.PodSpec

PodSpec is a description of a pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumes | List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes | false | v1.Volume array |
initContainers | List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/ | false | v1.Container array |
containers | List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated. | true | v1.Container array |
restartPolicy | Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy | false | string |
terminationGracePeriodSeconds | Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds. | false | integer (int64) |
activeDeadlineSeconds | Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer. | false | integer (int64) |
dnsPolicy | Set DNS policy for the pod. Defaults to "ClusterFirst". Valid values are ClusterFirstWithHostNet, ClusterFirst, Default or None. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to ClusterFirstWithHostNet. Note that None policy is an alpha feature introduced in v1.9 and CustomPodDNS feature gate must be enabled to use it. | false | string |
nodeSelector | NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node’s labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/ | false | object |
serviceAccountName | ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/ | false | string |
serviceAccount | DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead. | false | string |
automountServiceAccountToken | AutomountServiceAccountToken indicates whether a service account token should be automatically mounted. | false | boolean | false
nodeName | NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements. | false | string |
hostNetwork | Host networking requested for this pod. Use the host’s network namespace. If this option is set, the ports that will be used must be specified. Default to false. | false | boolean | false
hostPID | Use the host’s pid namespace. Optional: Default to false. | false | boolean | false
hostIPC | Use the host’s ipc namespace. Optional: Default to false. | false | boolean | false
securityContext | SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty. See type description for default values of each field. | false | v1.PodSecurityContext |
imagePullSecrets | ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod | false | v1.LocalObjectReference array |
hostname | Specifies the hostname of the Pod If not specified, the pod’s hostname will be set to a system-defined value. | false | string |
subdomain | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all. | false | string |
affinity | If specified, the pod’s scheduling constraints | false | v1.Affinity |
schedulerName | If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler. | false | string |
tolerations | If specified, the pod’s tolerations. | false | v1.Toleration array |
hostAliases | HostAliases is an optional list of hosts and IPs that will be injected into the pod’s hosts file if specified. This is only valid for non-hostNetwork pods. | false | v1.HostAlias array |
priorityClassName | If specified, indicates the pod’s priority. "SYSTEM" is a special keyword which indicates the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default. | false | string |
priority | The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority. | false | integer (int32) |
dnsConfig | Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy. This is an alpha feature introduced in v1.9 and CustomPodDNS feature gate must be enabled to use it. | false | v1.PodDNSConfig |

### v1.ContainerPort

ContainerPort represents a network port in a single container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services. | false | string |
hostPort | Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this. | false | integer (int32) |
containerPort | Number of port to expose on the pod’s IP address. This must be a valid port number, 0 < x < 65536. | true | integer (int32) |
protocol | Protocol for port. Must be UDP or TCP. Defaults to "TCP". | false | string |
hostIP | What host IP to bind the external port to. | false | string |

### v1.Lifecycle

Lifecycle describes actions that the management system should take in response to container lifecycle events. For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
postStart | PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks | false | v1.Handler |
preStop | PreStop is called immediately before a container is terminated. The container is terminated after the handler completes. The reason for termination is passed to the handler. Regardless of the outcome of the handler, the container is eventually terminated. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks | false | v1.Handler |

### v1.GlusterfsVolumeSource

Represents a Glusterfs mount that lasts the lifetime of a pod. Glusterfs volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
endpoints | EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | true | string |
path | Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | true | string |
readOnly | ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | false | boolean | false

### v1.Handler

Handler defines a specific action that should be taken

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
exec | One and only one of the following should be specified. Exec specifies the action to take. | false | v1.ExecAction |
httpGet | HTTPGet specifies the http request to perform. | false | v1.HTTPGetAction |
tcpSocket | TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported | false | v1.TCPSocketAction |

### v1.Toleration

The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys. | false | string |
operator | Operator represents a key’s relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category. | false | string |
value | Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string. | false | string |
effect | Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute. | false | string |
tolerationSeconds | TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system. | false | integer (int64) |

### v1beta1.StatefulSetList

StatefulSetList is a collection of StatefulSets.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata |  | false | v1.ListMeta |
items |  | true | v1beta1.StatefulSet array |

### v1.StatusCause

StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
reason | A machine-readable description of the cause of the error. If this value is empty there is no information available. | false | string |
message | A human-readable description of the cause of the error. This field may be presented as-is to a reader. | false | string |
field | The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed. Fields may appear more than once in an array of causes due to fields having multiple errors. Optional. Examples: "name" - the field "name" on the current resource "items[0].name" - the field "name" on the first array entry in "items" | false | string |

### v1beta1.Scale

Scale represents a scaling request for a resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata. | false | v1.ObjectMeta |
spec | defines the behavior of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status. | false | v1beta1.ScaleSpec |
status | current status of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status. Read-only. | false | v1beta1.ScaleStatus |

### v1beta1.ControllerRevision

DEPRECATED - This group version of ControllerRevision is deprecated by apps/v1beta2/ControllerRevision. See the release notes for more information. ControllerRevision implements an immutable snapshot of state data. Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard object’s metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | v1.ObjectMeta |
data | Data is the serialized representation of the state. | false | string |
revision | Revision indicates the revision of the state represented by Data. | true | integer (int64) |

### v1.RBDVolumeSource

Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
monitors | A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | true | string array |
image | The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd | false | string |
pool | The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | string |
user | The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | string |
keyring | Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | string |
secretRef | SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | v1.LocalObjectReference |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | boolean | false

### v1.ConfigMapProjection

Adapts a ConfigMap into a projected volume.

The contents of the target ConfigMap’s Data field will be presented in a projected volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. Note that this is identical to a configmap volume source without the default mode.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
optional | Specify whether the ConfigMap or it’s keys must be defined | false | boolean | false

### v1.PhotonPersistentDiskVolumeSource

Represents a Photon Controller persistent disk resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
pdID | ID that identifies Photon Controller persistent disk | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |

### v1.ScaleIOVolumeSource

ScaleIOVolumeSource represents a persistent ScaleIO volume

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
gateway | The host address of the ScaleIO API Gateway. | true | string |
system | The name of the storage system as configured in ScaleIO. | true | string |
secretRef | SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail. | true | v1.LocalObjectReference |
sslEnabled | Flag to enable/disable SSL communication with Gateway, default false | false | boolean | false
protectionDomain | The name of the ScaleIO Protection Domain for the configured storage. | false | string |
storagePool | The ScaleIO Storage Pool associated with the protection domain. | false | string |
storageMode | Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. | false | string |
volumeName | The name of a volume already created in the ScaleIO system that is associated with this volume source. | false | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### v1.HostPathType

### v1.Initializers

Initializers tracks the progress of initialization.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
pending | Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients. | true | v1.Initializer array |
result | If result is set with the Failure field, the object will be persisted to storage and then deleted, ensuring that other clients can observe the deletion. | false | v1.Status |

### v1.PodDNSConfig

PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
nameservers | A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed. | false | string array |
searches | A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed. | false | string array |
options | A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy. | false | v1.PodDNSConfigOption array |

### v1.Status

Status is a return value for calls that don’t return other objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | v1.ListMeta |
status | Status of the operation. One of: "Success" or "Failure". More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status | false | string |
message | A human-readable description of the status of this operation. | false | string |
reason | A machine-readable description of why this operation is in the "Failure" status. If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it. | false | string |
details | Extended data associated with the reason. Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type. | false | v1.StatusDetails |
code | Suggested HTTP return code for this status, 0 if not set. | false | integer (int32) |

### v1beta1.ScaleStatus

ScaleStatus represents the current status of a scale subresource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
replicas | actual number of observed instances of the scaled object. | true | integer (int32) |
selector | label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors | false | object |
targetSelector | label selector for pods that should match the replicas count. This is a serializated version of both map-based and more expressive set-based selectors. This is done to avoid introspection in the clients. The string will be in the same format as the query-param syntax. If the target type only supports map-based selectors, both this field and map-based selector field are populated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors | false | string |

### v1.NFSVolumeSource

Represents an NFS mount that lasts the lifetime of a pod. NFS volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
server | Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs | true | string |
path | Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs | true | string |
readOnly | ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs | false | boolean | false

### v1beta1.DeploymentList

DeploymentList is a list of Deployments.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | Standard list metadata. | false | v1.ListMeta |
items | Items is the list of Deployments. | true | v1beta1.Deployment array |

### v1beta1.DeploymentRollback

DEPRECATED. DeploymentRollback stores the information required to rollback a deployment.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
name | Required: This must match the Name of a deployment. | true | string |
updatedAnnotations | The annotations to be updated to a deployment | false | object |
rollbackTo | The config of this deployment rollback. | true | v1beta1.RollbackConfig |

### v1.HTTPHeader

HTTPHeader describes a custom header to be used in HTTP probes

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | The header field name | true | string |
value | The header field value | true | string |

### v1.FCVolumeSource

Represents a Fibre Channel volume. Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
targetWWNs | Optional: FC target worldwide names (WWNs) | false | string array |
lun | Optional: FC target lun number | false | integer (int32) |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false
wwids | Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously. | false | string array |

### v1.PodAntiAffinity

Pod anti affinity is a group of inter pod anti affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. | false | v1.PodAffinityTerm array |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. | false | v1.WeightedPodAffinityTerm array |

### v1beta1.StatefulSetStatus

StatefulSetStatus represents the current state of a StatefulSet.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
observedGeneration | observedGeneration is the most recent generation observed for this StatefulSet. It corresponds to the StatefulSet’s generation, which is updated on mutation by the API Server. | false | integer (int64) |
replicas | replicas is the number of Pods created by the StatefulSet controller. | true | integer (int32) |
readyReplicas | readyReplicas is the number of Pods created by the StatefulSet controller that have a Ready Condition. | false | integer (int32) |
currentReplicas | currentReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by currentRevision. | false | integer (int32) |
updatedReplicas | updatedReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by updateRevision. | false | integer (int32) |
currentRevision | currentRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [0,currentReplicas). | false | string |
updateRevision | updateRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [replicas-updatedReplicas,replicas) | false | string |
collisionCount | collisionCount is the count of hash collisions for the StatefulSet. The StatefulSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision. | false | integer (int32) |
conditions | Represents the latest available observations of a statefulset’s current state. | false | v1beta1.StatefulSetCondition array |

### v1.DeletionPropagation

### v1beta1.DeploymentStrategy

DeploymentStrategy describes how to replace existing pods with new ones.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type | Type of deployment. Can be "Recreate" or "RollingUpdate". Default is RollingUpdate. | false | string |
rollingUpdate | Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate. | false | v1beta1.RollingUpdateDeployment |

### v1.TCPSocketAction

TCPSocketAction describes an action based on opening a socket

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
port | Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. | true | string |
host | Optional: Host name to connect to, defaults to the pod IP. | false | string |

### v1.HTTPGetAction

HTTPGetAction describes an action based on HTTP Get requests.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Path to access on the HTTP server. | false | string |
port | Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. | true | string |
host | Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. | false | string |
scheme | Scheme to use for connecting to the host. Defaults to HTTP. | false | string |
httpHeaders | Custom headers to set in the request. HTTP allows repeated headers. | false | v1.HTTPHeader array |

### v1.StatusDetails

StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response. The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described). | false | string |
group | The group attribute of the resource associated with the status StatusReason. | false | string |
kind | The kind attribute of the resource associated with the status StatusReason. On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
uid | UID of the resource. (when there is a single resource which can be described). More info: http://kubernetes.io/docs/user-guide/identifiers#uids | false | string |
causes | The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes. | false | v1.StatusCause array |
retryAfterSeconds | If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action. | false | integer (int32) |

### v1.Container

A single application container that you want to run within a pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated. | true | string |
image | Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets. | false | string |
command | Entrypoint array. Not executed within a shell. The docker image’s ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container’s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell | false | string array |
args | Arguments to the entrypoint. The docker image’s CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container’s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell | false | string array |
workingDir | Container’s working directory. If not specified, the container runtime’s default will be used, which might be configured in the container image. Cannot be updated. | false | string |
ports | List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated. | false | v1.ContainerPort array |
envFrom | List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated. | false | v1.EnvFromSource array |
env | List of environment variables to set in the container. Cannot be updated. | false | v1.EnvVar array |
resources | Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources | false | v1.ResourceRequirements |
volumeMounts | Pod volumes to mount into the container’s filesystem. Cannot be updated. | false | v1.VolumeMount array |
volumeDevices | volumeDevices is the list of block devices to be used by the container. This is an alpha feature and may change in the future. | false | v1.VolumeDevice array |
livenessProbe | Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes | false | v1.Probe |
readinessProbe | Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes | false | v1.Probe |
lifecycle | Actions that the management system should take in response to container lifecycle events. Cannot be updated. | false | v1.Lifecycle |
terminationMessagePath | Optional: Path at which the file to which the container’s termination message will be written is mounted into the container’s filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated. | false | string |
terminationMessagePolicy | Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated. | false | string |
imagePullPolicy | Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images | false | string |
securityContext | Security options the pod should run with. More info: https://kubernetes.io/docs/concepts/policy/security-context/ More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/ | false | v1.SecurityContext |
stdin | Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false. | false | boolean | false
stdinOnce | Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false | false | boolean | false
tty | Whether this container should allocate a TTY for itself, also requires stdin to be true. Default is false. | false | boolean | false

### v1.PodSecurityContext

PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext. Field values of container.securityContext take precedence over field values of PodSecurityContext.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
seLinuxOptions | The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. | false | v1.SELinuxOptions |
runAsUser | The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. | false | integer (int64) |
runAsNonRoot | Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | boolean | false
supplementalGroups | A list of groups applied to the first process run in each container, in addition to the container’s primary GID. If unspecified, no groups will be added to any container. | false | integer (int32) array |
fsGroup | A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod: 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR’d with rw-rw | false | integer (int64) |

### v1.OwnerReference

OwnerReference contains enough information to let you identify an owning object. Currently, an owning object must be in the same namespace, so there is no namespace field.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
apiVersion | API version of the referent. | true | string |
kind | Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | true | string |
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | true | string |
uid | UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids | true | string |
controller | If true, this reference points to the managing controller. | false | boolean | false
blockOwnerDeletion | If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned. | false | boolean | false

### v1beta1.ControllerRevisionList

ControllerRevisionList is a resource containing a list of ControllerRevision objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources | false | string |
metadata | More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | v1.ListMeta |
items | Items is the list of ControllerRevisions | true | v1beta1.ControllerRevision array |

### v1.APIResource

APIResource specifies the name of a resource and whether it is namespaced.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | name is the plural name of the resource. | true | string |
singularName | singularName is the singular name of the resource. This allows clients to handle plural and singular opaquely. The singularName is more correct for reporting status on a single item and both singular and plural are allowed from the kubectl CLI interface. | true | string |
namespaced | namespaced indicates if a resource is namespaced or not. | true | boolean | false
group | group is the preferred group of the resource. Empty implies the group of the containing resource list. For subresources, this may have a different value, for example: Scale". | false | string |
version | version is the preferred version of the resource. Empty implies the version of the containing resource list For subresources, this may have a different value, for example: v1 (while inside a v1beta1 version of the core resource’s group)". | false | string |
kind | kind is the kind for the resource (e.g. Foo is the kind for a resource foo) | true | string |
verbs | verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy) | true | string array |
shortNames | shortNames is a list of suggested short names of the resource. | false | string array |
categories | categories is a list of the grouped resources this resource belongs to (e.g. all) | false | string array |

### v1.VolumeDevice

volumeDevice describes a mapping of a raw block device within a container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | name must match the name of a persistentVolumeClaim in the pod | true | string |
devicePath | devicePath is the path inside of the container that the device will be mapped to. | true | string |

### v1.NodeSelectorRequirement

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | The label key that the selector applies to. | true | string |
operator | Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt. | true | string |
values | An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. | false | string array |

### v1.HostPathVolumeSource

Represents a host path mapped into a pod. Host path volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath | true | string |
type | Type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath | false | v1.HostPathType |

### v1.PodDNSConfigOption

PodDNSConfigOption defines DNS resolver options of a pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Required. | false | string |
value |  | false | string |

### v1.SecretProjection

Adapts a secret into a projected volume.

The contents of the target Secret’s Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
optional | Specify whether the Secret or its key must be defined | false | boolean | false

### v1.CinderVolumeSource

Represents a cinder volume resource in Openstack. A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeID | volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | string |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | boolean | false

### v1.SecurityContext

SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext. When both are set, the values in SecurityContext take precedence.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
capabilities | The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. | false | v1.Capabilities |
privileged | Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. | false | boolean | false
seLinuxOptions | The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | v1.SELinuxOptions |
runAsUser | The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | integer (int64) |
runAsNonRoot | Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | boolean | false
readOnlyRootFilesystem | Whether this container has a read-only root filesystem. Default is false. | false | boolean | false
allowPrivilegeEscalation | AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN | false | boolean | false

### v1.AWSElasticBlockStoreVolumeSource

Represents a Persistent Disk resource in AWS.

An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeID | Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore | false | string |
partition | The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). | false | integer (int32) |
readOnly | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore | false | boolean | false

### v1.QuobyteVolumeSource

Represents a Quobyte mount that lasts the lifetime of a pod. Quobyte volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
registry | Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes | true | string |
volume | Volume is a string that references an already created Quobyte volume by name. | true | string |
readOnly | ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false. | false | boolean | false
user | User to map volume access to Defaults to serivceaccount user | false | string |
group | Group to map volume access to Default is no group | false | string |

### v1.WatchEvent

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type |  | true | string |
object |  | true | string |

### v1.LabelSelectorRequirement

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | key is the label key that the selector applies to. | true | string |
operator | operator represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist. | true | string |
values | values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. | false | string array |

### v1.EnvVar

EnvVar represents an environment variable present in a Container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the environment variable. Must be a C_IDENTIFIER. | true | string |
value | Variable references $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "". | false | string |
valueFrom | Source for the environment variable’s value. Cannot be used if value is not empty. | false | v1.EnvVarSource |

### v1.PersistentVolumeAccessMode

### v1.ResourceRequirements

ResourceRequirements describes the compute resource requirements.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
limits | Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ | false | object |
requests | Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/ | false | object |

### v1.HostAlias

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod’s hosts file.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
ip | IP address of the host file entry. | false | string |
hostnames | Hostnames for the above IP address. | false | string array |

### v1.PodTemplateSpec

PodTemplateSpec describes the data a pod should have when created from a template

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
metadata | Standard object’s metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata | false | v1.ObjectMeta |
spec | Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status | false | v1.PodSpec |

### v1.NodeSelector

A node selector represents the union of the results of one or more label queries over a set of nodes; that is, it represents the OR of the selectors represented by the node selector terms.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
nodeSelectorTerms | Required. A list of node selector terms. The terms are ORed. | true | v1.NodeSelectorTerm array |

### v1.Patch

Patch is provided to give a concrete name and type to the Kubernetes PATCH request body.

### v1beta1.DeploymentCondition

DeploymentCondition describes the state of a deployment at a certain point.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type | Type of deployment condition. | true | string |
status | Status of the condition, one of True, False, Unknown. | true | string |
lastUpdateTime | The last time this condition was updated. | false | string |
lastTransitionTime | Last time the condition transitioned from one status to another. | false | string |
reason | The reason for the condition’s last transition. | false | string |
message | A human readable message indicating details about the transition. | false | string |

### v1.ConfigMapEnvSource

ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap’s Data field will represent the key-value pairs as environment variables.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
optional | Specify whether the ConfigMap must be defined | false | boolean | false

### v1.StorageOSVolumeSource

Represents a StorageOS persistent volume resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeName | VolumeName is the human-readable name of the StorageOS volume. Volume names are only unique within a namespace. | false | string |
volumeNamespace | VolumeNamespace specifies the scope of the volume within StorageOS. If no namespace is specified then the Pod’s namespace will be used. This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created. | false | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false
secretRef | SecretRef specifies the secret to use for obtaining the StorageOS API credentials. If not specified, default values will be attempted. | false | v1.LocalObjectReference |

### v1beta1.StatefulSetUpdateStrategy

StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates. It includes any additional parameters necessary to perform the update for the indicated strategy.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type | Type indicates the type of the StatefulSetUpdateStrategy. | false | string |
rollingUpdate | RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType. | false | v1beta1.RollingUpdateStatefulSetStrategy |

### v1.NodeAffinity

Node affinity is a group of node affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node. | false | v1.NodeSelector |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred. | false | v1.PreferredSchedulingTerm array |

### v1.AzureDataDiskKind

### v1.PreferredSchedulingTerm

An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it’s a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
weight | Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100. | true | integer (int32) |
preference | A node selector term, associated with the corresponding weight. | true | v1.NodeSelectorTerm |

### v1.ConfigMapKeySelector

Selects a key from a ConfigMap.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names | false | string |
key | The key to select. | true | string |
optional | Specify whether the ConfigMap or it’s key must be defined | false | boolean | false

### v1.AzureDataDiskCachingMode

### any

Represents an untyped JSON map - see the description of the field for more info about the structure of this object.